=== debian/changelog ===
hmat-oss (1.0.4-2ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 03:34:10 +0000

hmat-oss (1.0.4-2) unstable; urgency=low

  * Upload to unstable (Closes: #775738)

 -- Denis Barbier <barbier@debian.org>  Sun, 25 Jan 2015 11:22:12 +0000

hmat-oss (1.0.4-1) unstable; urgency=low

  * Initial release

 -- Julien Schueller <schueller@phimeca.com>  Sat, 22 Nov 2014 21:39:33 +0100
