=== debian/control ===
Source: hmat-oss
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julien Schueller <schueller@phimeca.com>, Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 8), quilt, cmake, liblapack-dev, libblas-dev
Standards-Version: 3.9.6
Homepage: https://github.com/jeromerobert/hmat-oss
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/hmat-oss.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/hmat-oss.git -b debian/experimental

Package: libhmat-oss1v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libhmat-oss1
Replaces: libhmat-oss1
Description: dynamic libraries for HMat 
 A hierarchical matrix C/C++ library including a LU solver.

Package: libhmat-oss-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libhmat-oss1v5 (= ${binary:Version}),
 liblapack-dev, libblas-dev
Description: headers and development libraries for HMat
 A hierarchical matrix C/C++ library including a LU solver.
 
Package: libhmat-oss1v5-dbg
Section: debug
Architecture: any
Depends: libhmat-oss1v5 (= ${binary:Version}), ${misc:Depends}
Conflicts: libhmat-oss1-dbg
Replaces: libhmat-oss1-dbg
Description: debug symbols for HMat 
 A hierarchical matrix C/C++ library including a LU solver.
