## hmat-oss 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,10 @@
 #  http://github.com/jeromerobert/hmat-oss
 
 cmake_minimum_required(VERSION 2.8)
+
+if (POLICY CMP0018)
+  cmake_policy (SET CMP0018 OLD)
+endif()
 
 # Set CMAKE_BUILD_TYPE to Release by default.
 # Must be done before calling project()
@@ -43,7 +47,7 @@
 
 if(NOT HMAT_VERSION)
     include(GitVersion)
-    git_version(HMAT 1.0.4)
+    git_version(HMAT 1.2.0)
 endif()
 set(HMAT_SO_VERSION 1)
 
@@ -97,6 +101,17 @@
 opt_flag("-ffast-math")
 opt_flag("-funsafe-math-optimizations")
 
+if(CMAKE_SIZEOF_VOID_P EQUAL 4)
+   set(HMAT_32BITS TRUE)
+endif()
+
+# Warning flags
+
+if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
+  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
+endif()
+
 # ========================
 # SYSTEM & EXTERNAL LIBS
 # ========================
@@ -114,12 +129,14 @@
     set(RT_LIBRARY rt)
 endif()
 
-find_package(OpenMP)
-if(OPENMP_FOUND)
-    set(HAVE_OMP_H TRUE)
-    set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
-    set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
-    set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
+option(HMAT_DISABLE_OPENMP "Let HMat disable OpenMP (require OpenMP support)" ON)
+if(HMAT_DISABLE_OPENMP)
+    find_package(OpenMP)
+    if(OPENMP_FOUND)
+        set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
+        set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
+        set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
+    endif()
 endif()
 
 # MKL
@@ -128,6 +145,16 @@
   include_directories(${MKL_INCLUDE_DIRS})
   set(CMAKE_C_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_C_FLAGS}")
   set(CMAKE_CXX_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
+endif()
+
+# JeMalloc
+option(HMAT_JEMALLOC "Use jemalloc for matrix blocks allocation." OFF)
+if(HMAT_JEMALLOC)
+    find_package(JeMalloc REQUIRED)
+    if(JEMALLOC_FOUND)
+        set(HAVE_JEMALLOC TRUE)
+        include_directories(${JEMALLOC_INCLUDE_DIR})
+    endif()
 endif()
 
 option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
@@ -184,7 +211,6 @@
         find_path(CBLAS_INCLUDE_DIRS NAMES cblas.h DOC "CBLAS include directory")
         if(CBLAS_INCLUDE_DIRS)
             set(CMAKE_REQUIRED_INCLUDES ${CBLAS_INCLUDE_DIRS})
-            include_directories(${CBLAS_INCLUDE_DIRS})
             check_include_file("cblas.h" HAVE_CBLAS_H)
             if (NOT HAVE_CBLAS_H)
                 message(FATAL_ERROR "cblas.h not found")
@@ -195,13 +221,17 @@
     else (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
         find_package(CBLAS REQUIRED)
     endif()
+    include_directories(${CBLAS_INCLUDE_DIRS})
 endif ()
 
 # ========================
 # Configuration file
 # ========================
 configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
-configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config.h")
+configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config-oss.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config-oss.h")
+if(NOT HMAT_SKIP_CONFIG)
+  configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config.h")
+endif()
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
 # ============================
@@ -209,24 +239,23 @@
 # ============================
 
 # Sources
-file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.cpp)
-list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp)
+file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.[ch]pp include/*.h)
+list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp
 
 link_directories(${PROJECT_BINARY_DIR} ${BLAS_LIBRARY_DIRS})
 
 add_definitions(-D_GNU_SOURCE)
-#  We want to enforce assertions even in Release mode
-add_definitions(-UNDEBUG)
 
 if (MSVC)
     add_definitions(-D__func__=__FUNCTION__)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+    add_definitions(-DNOMINMAX)
 endif ()
 
 # lib HMAT
 if(HMAT_OSS_STATIC AND BUILD_SHARED_LIBS)
     add_library(${PROJECT_NAME} STATIC ${HMAT_SOURCES})
-    if(BUILD_SHARED_LIBS)
+    if(BUILD_SHARED_LIBS AND NOT WIN32)
         set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS -fPIC)
     endif()
 else()
@@ -266,6 +295,10 @@
     target_link_libraries(${PROJECT_NAME} ${_LINK_PRIVATE} ${MKL_LINKER_FLAGS})
 endif()
 
+if(JEMALLOC_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${_LINK_PRIVATE} ${JEMALLOC_LIBRARIES})
+endif()
+
 if (HAVE_LIBRT)
     # rt is needed by my_chrono.hpp
     target_link_libraries(${PROJECT_NAME} ${_LINK_PUBLIC} ${RT_LIBRARY})
@@ -285,32 +318,11 @@
 endif("${isSystemDir}" STREQUAL "-1")
 
 option(BUILD_EXAMPLES "build examples" OFF)
+option(INSTALL_EXAMPLES "install examples" OFF)
+
 macro(hmat_add_example name source)
   if (BUILD_EXAMPLES)
     if (MSVC OR WINTEL)
       set_source_files_properties("examples/${source}" PROPERTIES COMPILE_FLAGS "-D_USE_MATH_DEFINES")
     endif ()
     if (MSVC)
-      #  No complex.h on MSVC, compile with C++
-      set_source_files_properties("examples/${source}" PROPERTIES LANGUAGE CXX)
-    endif ()
-    add_executable(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_SOURCE_DIR}/examples/${source})
-    target_link_libraries(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_NAME})
-    install(TARGETS ${HMAT_PREFIX_EXAMPLE}${name} DESTINATION "${RELATIVE_INSTALL_BIN_DIR}/examples" COMPONENT Runtime)
-  endif ()
-endmacro()
-
-hmat_add_example(kriging kriging.cpp)
-hmat_add_example(cylinder cylinder.cpp)
-hmat_add_example(c-cylinder c-cylinder.c)
-hmat_add_example(c-simple-cylinder c-simple-cylinder.c)
-hmat_add_example(c-simple-kriging c-simple-kriging.c)
-
-
-install(DIRECTORY include/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
-install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
-set(CXX_HMAT_HEADERS "full_matrix;hmat_cpp_interface;compression;h_matrix;"
-    "default_engine;cluster_tree;tree;interaction;data_types")
-foreach(header ${CXX_HMAT_HEADERS})
-    set(HMAT_HEADERS src/${header}.hpp;${HMAT_HEADERS})
-endforeach()
