=== debian/changelog ===
hmat-oss (1.2.0-2ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Conflict/Replace/Provide renamed library package.  This change can
      be dropped after the 18.04 release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 00:54:39 -0700

hmat-oss (1.2.0-2) unstable; urgency=medium

  * New patch: 0002-Fix-compilation-on-Linux-32-bits-systems.patch
    Fix compilation on 32bit systems, thanks Jérôme Robert.

 -- Denis Barbier <barbier@debian.org>  Thu, 20 Oct 2016 21:08:08 +0100

hmat-oss (1.2.0-1ubuntu1) zesty; urgency=low

  * Sync from Debian unstable.
  * Revert package rename for g++5 ABI transition, since the affected symbols
    were not part of the ABI; and Provide: the renamed package for
    compatibility.  These changes can be dropped after the 18.04 release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 20 Oct 2016 01:01:30 -0700

hmat-oss (1.2.0-1) unstable; urgency=low

  * New upstream version
  * This version builds with gcc 6.  (Closes: #831143)
  * New patch: 0001-make-build-reproducible.patch
    Makes builds reproducible.

 -- Denis Barbier <barbier@debian.org>  Wed, 19 Oct 2016 21:20:33 +0100
