## hmat-oss 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 if(NOT HMAT_VERSION)
     include(GitVersion)
-    git_version(HMAT 1.2.0)
+    git_version(HMAT 1.5.0)
 endif()
 set(HMAT_SO_VERSION 1)
 
@@ -105,13 +105,6 @@
    set(HMAT_32BITS TRUE)
 endif()
 
-# Warning flags
-
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
-  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
-endif()
-
 # ========================
 # SYSTEM & EXTERNAL LIBS
 # ========================
@@ -156,6 +149,19 @@
         include_directories(${JEMALLOC_INCLUDE_DIR})
     endif()
 endif()
+
+# Context timers
+option(HMAT_CONTEXT "Use context timers." OFF)
+if(HMAT_CONTEXT)
+    message(STATUS "Use context timers")
+    set(HAVE_CONTEXT TRUE)
+endif()
+
+# Build date export through hmat_get_build_date()
+option(HMAT_EXPORT_BUILD_DATE "Hmat exports build date." OFF)
+if(HMAT_EXPORT_BUILD_DATE)
+    message(STATUS "Exports build date")
+endif(HMAT_EXPORT_BUILD_DATE)
 
 option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
 # BLAS/LAPACK
@@ -225,6 +231,16 @@
 endif ()
 
 # ========================
+# Warning flags
+# ========================
+include(CheckCXXCompilerFlag)
+check_cxx_compiler_flag("-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix" HAVE_GCC_WARNING_FLAGS)
+if(HAVE_GCC_WARNING_FLAGS)
+  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
+  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
+endif()
+
+# ========================
 # Configuration file
 # ========================
 configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
@@ -240,7 +256,7 @@
 
 # Sources
 file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.[ch]pp include/*.h)
-list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp
+list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp (and the other *_engine.cpp) and h_matrix.cpp
 
 link_directories(${PROJECT_BINARY_DIR} ${BLAS_LIBRARY_DIRS})
 
@@ -309,20 +325,3 @@
 endif()
 
 # Examples
-include_directories(${PROJECT_SOURCE_DIR}/src)
-
-# Install examples with RPATH
-list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${INSTALL_LIB_DIR}" isSystemDir)
-if("${isSystemDir}" STREQUAL "-1")
-    set(CMAKE_INSTALL_RPATH "${INSTALL_LIB_DIR}")
-endif("${isSystemDir}" STREQUAL "-1")
-
-option(BUILD_EXAMPLES "build examples" OFF)
-option(INSTALL_EXAMPLES "install examples" OFF)
-
-macro(hmat_add_example name source)
-  if (BUILD_EXAMPLES)
-    if (MSVC OR WINTEL)
-      set_source_files_properties("examples/${source}" PROPERTIES COMPILE_FLAGS "-D_USE_MATH_DEFINES")
-    endif ()
-    if (MSVC)
