=== debian/changelog ===
hmat-oss (1.7.1-3) unstable; urgency=medium

  * Solving issues that has the package FTBFS with g++-12:
    - incorrect precedence of + and ?: operators
    - unitialization error due to conditional initialization of an array
    (Closes: #1012945)
  * Raising Standards version to 4.6.1 (no change)
  * Marking the shared lib package as Multi-Arch: same

 -- Pierre Gruet <pgt@debian.org>  Sun, 19 Jun 2022 15:14:35 +0200

hmat-oss (1.7.1-2) unstable; urgency=medium

  * Upload to unstable to start the transition auto-hmat-oss
  * Making the autopkgtests depend on build-essential rather than gcc

 -- Pierre Gruet <pgt@debian.org>  Tue, 19 Apr 2022 15:08:33 +0200

hmat-oss (1.7.1-1) experimental; urgency=medium

  * New upstream version 1.7.1
  * Depending on debhelper-compat 13
  * Correcting d/watch, and upgrading it to version 4
  * Performing a SONAME bump, due to non backward-compatible ABI changes
  * Providing descriptions of packages with a bit more details
  * Adding myself as uploader
  * Simplifying debian/gbp.conf
  * Raising Standards version to 4.6.0:
    - Providing https Salsa links in Vcs-* fields
    - Extra priority is now optional
    - Using https form of format URL in d/copyright
    - Rules-Requires-Root: no
    - Dropping old-fashioned -dbg package
  * Removing all upstreamed patches
  * Removing build-dependency on quilt
  * Removing useless dependencies of the -dev package
  * Reworking d/rules:
    - Lighter override of dh_auto_configure
    - No tweaking of DEB_BUILD_OPTIONS
    - Hardening using /usr/share/dpkg/buildflags.mk
  * Refreshing d/copyright
  * Installing the library in /usr/lib/triplet
  * Correcting a spelling error in the source
  * Adding a Lintian override for not providing a symbols file
  * Adding an autopkgtest and providing it as example in the -dev package
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Pierre Gruet <pgt@debian.org>  Sat, 02 Apr 2022 20:44:55 +0200

hmat-oss (1.2.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with glibc 2.33. (Closes: #1002167)

 -- Adrian Bunk <bunk@debian.org>  Wed, 19 Jan 2022 18:14:34 +0200

hmat-oss (1.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS. (Closes: #897768)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 02 May 2020 00:18:14 +0100
