=== debian/control ===
Source: hmat-oss
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julien Schueller <schueller@phimeca.com>,
           Denis Barbier <barbier@debian.org>,
           Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.6.1
Homepage: https://github.com/jeromerobert/hmat-oss
Vcs-Browser: https://salsa.debian.org/science-team/hmat-oss
Vcs-Git: https://salsa.debian.org/science-team/hmat-oss.git
Rules-Requires-Root: no

Package: libhmat-oss2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: hierarchical matrix C/C++ library (shared library)
 This library allows one to compute hierarchical matrices, which are tools from
 numerical mathematics used to approximate non-sparse matrices.
 .
 The implementation uses lower-upper (LU) decompositions.
 .
 This package contains the shared library.

Package: libhmat-oss-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libhmat-oss2 (= ${binary:Version})
Description: hierarchical matrix C/C++ library (development files)
 This library allows one to compute hierarchical matrices, which are tools from
 numerical mathematics used to approximate non-sparse matrices.
 .
 The implementation uses lower-upper (LU) decompositions.
 .
 This package contains the development files.
